sub get_port_data{ 
   my ($host,$port,$port_selection) = @_; 
   my $timeout = 5; $max_socket_lines = 20;
   my $found_server = 0; my $return_value = "zippo"; my $diff = 999;
   use IO::Socket;
   $socket = IO::Socket::INET->new(PeerAddr => $host,
                                   PeerPort => $port,
                                   Proto    => "tcp",
                                   Type     =>SOCK_STREAM,
                                   Timeout  => $timeout)
          or return "<font color=\"red\">Socket Open failed on $host:$port : $@ </font>";
   if ($port eq "13" ) {
      print $socket "";
      $remote_date = get_socket_value($timeout);
      if ($remote_date =~ /Socket timed out/) {
         $return_value = $remote_date;
      } else {
         $diff = &get_diff_seconds($remote_date);
         $return_value = sprintf("%5s%s" ,"$diff" , "   $remote_date");
      }
   } elsif (( $port eq "21" ) || ( $port eq "22" ) || ( $port eq "25" ) || ( $port eq "110") || ( $port eq 143)) {
      print $socket "quit\n\n";
      $return_value = get_socket_value($timeout);
   } elsif ( $port eq "80" ) {
      print $socket "HEAD / HTTP/1.0\n\n";
      $return_value = "<font color=\"red\">Stopping after getting more than $max_socket_lines of output</font>";
      for ( $line =1 ; $line < $max_socket_lines ; $line++ ) {
         if ( eof($socket) ) { 
            $return_value = "Could not determine Web Server" if (! $found_server); 
            last; 
         } else {
            $_ = get_socket_value($timeout);
            if ( /Server/ ) {
               s/Server: //;
               $return_value = "$_";
               $found_server=1;
               last; 
            }
         }
      }
   } else {
      $return_value = "<font color=\"red\">We do not have code to handle $port - let $author know</font>";
   }
   close($socket); 
   if (( defined($expec{$port_selection}) ) && ( $return_value !~ /Socket timed out/) ){ 
      if ($port eq "13" ) {
         $return_value = "<font color=\"red\">" . "$return_value" . "</font>" if ( abs($diff) > $expec{$port_selection} );
      } else {
         $return_value = "<font color=\"red\">" . "$return_value" . "</font>" if ( $return_value !~ /$expec{$port_selection}/ );
      }
   }
   return $return_value;
}


sub get_socket_value {
   my ($timeout) = @_; 
   $SIG{ALRM} = sub { die "timeout" };
   eval {
      alarm ($timeout);
      $_ = <$socket>;
      alarm(0);
   };
   if ( $@ ) {
      if ( $@ =~ /timeout/ ) {
         $_ = "<font color=\"red\">Socket timed out after $timeout seconds</font>";
      } else {
         alarm(0);
         die;
      }
   }
   chomp();
   s/\r//;
   return $_;
}



sub get_diff_seconds{ 
   # CPAN stuff could do this easier for you ...
   # But this is complicated by the fact that you don't know the timezone ...
   my ($remote_date,$rdaytime,$rmday) = @_; 
   my ($seconds,$minutes,$hours,$daytime,$mday,$month,$year);
   my ($local_date,$local_sec,$remote_sec,$diff);
   use Time::Local;
   $local_date = localtime;

   # NT adds commands and moves the year around ...
   $remote_date =~ s/\,//g;
   ($_,$_,$rmday,$rdaytime) = split(/\s+/,$remote_date); 
   ($_,$_,$_,$rmday,$rdaytime) = split(/\s+/,$remote_date) if ( ! ($rdaytime =~ /\:/)); 
   ($hours,$minutes,$seconds) = split(/:/,$rdaytime);

   ($_,$_,$_,$mday,$month,$year)=localtime();
   $remote_sec = timelocal($seconds,$minutes,$hours,$mday,$month,$year);

# Giant kludge to work around time zone stuff and testing around midnight ...
   if ( $rmday == $mday ) {
      #NOOP
   } elsif (( $rmday == ($mday+1)) || ( ($rmday == 1) && ( $rmday !=e $mday ))) {
      $remote_sec = $remote_sec + ( 24*60*60);
   } elsif (( $mday == ($rmday+1)) || ( ($mday == 1) && ( $rmday != $mday ))) {
      $remote_sec = $remote_sec - ( 24*60*60);
   } else {
      print "something wierd happening here with timezones ...\n";
      print "local date is $local_date and remote date is $remote_date ...\n";
      print "Let the $author know ... \n";
   }

   ($_,$_,$_,$daytime) = split(/\s+/,$local_date); 
   ($hours,$minutes,$seconds) = split(/:/,$daytime);
   ($_,$_,$_,$mday,$month,$year)=localtime();
   $local_sec = timelocal($seconds,$minutes,$hours,$mday,$month,$year);
   $diff = $remote_sec - $local_sec;
# timezone correction - we assume you are at least withen an hour!   ;-)
   if (abs($diff) > 3500) {
      $diff = $diff - ( 3600*int(($diff*1.2)/3600)); 
   }
   return $diff;
}

1; 
